org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class PropertyMapStep<K,E>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep<Element,Map<K,E>>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.PropertyMapStep<K,E>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Map<K,E>>>, Step<Element,Map<K,E>>, ByModulating, Configuring, Parameterizing, TraversalParent

      public class PropertyMapStep<K,E>
      extends MapStep<Element,Map<K,E>>
      implements TraversalParent, ByModulating, Configuring

  Author:
    Marko A. Rodriguez (http://markorodriguez.com), Daniel Kuppitz (http://gremlin.guru)
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String[]` | `propertyKeys`
    `protected Traversal.Admin<Element,? extends Property>` | `propertyTraversal`
    `protected PropertyType` | `returnType`
    `protected int` | `tokens`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PropertyMapStep(Traversal.Admin traversal, boolean includeTokens, PropertyType propertyType, String... propertyKeys)` Deprecated. As of release 3.4.0, replaced by `PropertyMapStep(Traversal.Admin, PropertyType, String...)`.
    `PropertyMapStep(Traversal.Admin traversal, PropertyType propertyType, String... propertyKeys)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `PropertyMapStep<K,E>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `void` | `configure(Object... keyValues)` Accept a configuration to the `Step`.
    `int` | `getIncludedTokens()`
    `List<Traversal.Admin<K,E>>` | `getLocalChildren()`
    `Parameters` | `getParameters()` Gets the parameters on the step.
    `String[]` | `getPropertyKeys()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `PropertyType` | `getReturnType()`
    `int` | `hashCode()`
    `boolean` | `isIncludeTokens()` Deprecated. As of release 3.4.0, replaced by `getIncludedTokens()`.
    `protected Map<K,E>` | `map(Traverser.Admin<Element> traverser)`
    `void` | `modulateBy(Traversal.Admin<?,?> selectTraversal)`
    `void` | `setPropertyTraversal(Traversal.Admin<Element,? extends Property> propertyTraversal)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep

      `processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, reset, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Field Detail

    - #### propertyKeys

          protected final String[] propertyKeys

    - #### returnType

          protected final PropertyType returnType

    - #### tokens

          protected int tokens

    - #### propertyTraversal

          protected Traversal.Admin<Element,? extends Property> propertyTraversal

  - ### Constructor Detail

    - #### PropertyMapStep

          @Deprecated
          public PropertyMapStep(Traversal.Admin traversal,
                                             boolean includeTokens,
                                             PropertyType propertyType,
                                             String... propertyKeys)

      Deprecated. As of release 3.4.0, replaced by `PropertyMapStep(Traversal.Admin, PropertyType, String...)`.

    - #### PropertyMapStep

          public PropertyMapStep(Traversal.Admin traversal,
                                 PropertyType propertyType,
                                 String... propertyKeys)

  - ### Method Detail

    - #### map

          protected Map<K,E> map(Traverser.Admin<Element> traverser)

      Specified by:
        `map` in class `MapStep<Element,Map<K,E>>`

    - #### configure

          public void configure(Object... keyValues)

      Description copied from interface: `Configuring`
      Accept a configuration to the `Step`. Note that this interface extends `Parameterizing` and so there is an expectation that the `Step` implementation will have a `Parameters` instance that will house any values passed to this method. Storing these configurations in `Parameters` is not a requirement however, IF the configuration is an expected option for the step and can be stored on a member field that can be accessed on the step by more direct means (i.e. like a getter method).
      Specified by:
        `configure` in interface `Configuring`

    - #### getParameters

          public Parameters getParameters()

      Description copied from interface: `Parameterizing`
      Gets the parameters on the step.
      Specified by:
        `getParameters` in interface `Parameterizing`

    - #### getLocalChildren

          public List<Traversal.Admin<K,E>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> selectTraversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### setPropertyTraversal

          public void setPropertyTraversal(Traversal.Admin<Element,? extends Property> propertyTraversal)

    - #### getReturnType

          public PropertyType getReturnType()

    - #### getPropertyKeys

          public String[] getPropertyKeys()

    - #### isIncludeTokens

          @Deprecated
          public boolean isIncludeTokens()

      Deprecated. As of release 3.4.0, replaced by `getIncludedTokens()`.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<Element,Map<K,E>>`

    - #### clone

          public PropertyMapStep<K,E> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<Element,Map<K,E>>`
      Overrides:
        `clone` in class `AbstractStep<Element,Map<K,E>>`
      Returns:
        The cloned step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<Element,Map<K,E>>`

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<Element,Map<K,E>>`
      Overrides:
        `setTraversal` in class `AbstractStep<Element,Map<K,E>>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<Element,Map<K,E>>`
      Returns:
        the set of requirements

    - #### getIncludedTokens

          public int getIncludedTokens()

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.